#!/bin/sh
-d="$HOME/.dotfiles"
-for x in .*; do ln -vwis "$d/$x" "$HOME/$x"; done
-ln -vwis "$d/i3-config" "$HOME/.config/i3/config"
-ln -vwis "$d/i3status-config" "$HOME/.config/i3status/config"
+
+# install location and source files
+: ${DEST:=$(realpath "$HOME")}
+: ${SRC:=$(dirname "$(realpath "$0")")}
+
+# confirm XDG vars we care about are set up
+: ${LOCAL:=.local} # NOTE: needed for bin, which has no xdg var
+: ${XDG_DATA_HOME:=$DEST/$LOCAL/share}
+: ${XDG_CONFIG_HOME:=$DEST/.config}
+: ${XDG_STATE_HOME:=$DEST/$LOCAL/state}
+: ${XDG_CACHE_HOME:=$DEST/.cache}
+
+# these are the vars we actually use
+share="${XDG_DATA_HOME#$DEST/}"
+etc="${XDG_CONFIG_HOME#$DEST/}"
+state="${XDG_STATE_HOME#$DEST/}"
+cache="${XDG_CACHE_HOME#$DEST/}"
+
+# test
+devnull=/dev/null
+if [ "${DOTFILES_TEST+x}" = x ]; then
+ echo "Running test -- no changes will be applied"
+ devnull=/dev/stdout
+ _cd() {
+ echo "-- cd $PWD --> $*";
+ cd $*;
+ }
+ alias cd="_cd"
+ alias mkdir="echo -- mkdir"
+ alias rmdir="echo -- rmdir"
+ alias ln="echo -- ln"
+ alias rm="echo -- rm"
+ alias mv="echo -- mv"
+ alias sh="echo -- sh"
+fi
+
+# ensure ostype
+# NOTE: copied from .zshenv
+if [ -z "$OSTYPE" ]; then
+ OSTYPE=$(uname -s | tr '[:upper:]' '[:lower:]')
+fi
+
+# accomodate multiple userlands
+# XXX: assuming GNU by default
+# TODO: test for GNU, fallback to POSIX instead (no -n)
+lnargs=-sfnv
+case "$OSTYPE" in
+ freebsd*) lnargs=-sFhv;;
+ netbsd|openbsd*) lnargs=-sfhv;;
+esac
+
+# save pwd
+old_pwd="$PWD"
+
+cd "$DEST"
+
+# create preferred folder structure
+mkdir -pm 760 "$share" "$etc" "$state" "$cache"
+ln $lnargs "$DEST/$etc" "$LOCAL/etc"
+mkdir -p "$LOCAL/bin" "$share/fonts" "$share/themes" "$share/icons"
+
+# clean out old links
+# TODO: doesn't remove dead links if realpath fails; this happens if the link
+# target doesn't exist under busybox
+find . "$share" "$etc" \
+ "$LOCAL/bin" "$share/fonts" "$share/themes" "$share/icons" \
+ "$etc/gnupg" .ssh .termux \
+ -xdev -mindepth 1 -maxdepth 1 -type l -exec sh -c '
+ r="$(realpath "{}")"
+ [ "${r#'"$SRC"'/}" != "$r" ] &&
+ '"$([ "${DOTFILES_TEST+x}" = x ] && echo 'echo +++ ')"'unlink "{}"' \;
+
+cd "$SRC" >$devnull
+
+l() {
+ # TODO: use install?
+ d="$DEST/${1:-$x}"
+ [ -L "$d" -o \! -e "$d" ] && ln $lnargs "$SRC/${2:-$x}" "$d" ||
+ echo "!!! File exists and is not a link: $1"
+}
+
+# generic links
+find base -mindepth 1 -maxdepth 1 | while read -r x; do l "${x#base/}"; done
+find bin -mindepth 1 -maxdepth 1 | while read -r x; do l "$LOCAL/$x"; done
+find share -mindepth 1 -maxdepth 1 | while read -r x; do l "$share${x#share}"; done
+find etc -mindepth 1 -maxdepth 1 | while read -r x; do l "$etc${x#etc}"; done
+
+# xorg/wayland resources
+find gui -mindepth 1 -maxdepth 1 | while read -r y; do
+ case "${y#gui/}" in
+ icons|themes)
+ find "$y" -mindepth 1 -maxdepth 2 -type d | while read -r x; do
+ [ ! -e "$x/index.theme" ] && continue
+ command -v gtk-update-icon-cache >$devnull 2>&1 &&
+ gtk-update-icon-cache -f "$x"
+ l "$share${y#gui}/$(basename "$x")"
+ done
+ ;;
+ fonts)
+ find "$y" -mindepth 2 -maxdepth 2 -type d | while read -r x; do
+ command -v mkfontscale >$devnull 2>&1 && mkfontscale "$x"
+ command -v mkfontdir >$devnull 2>&1 && mkfontdir "$x"
+ [ "$(head -1 "$x/fonts.scale" >$devnull 2>&1)" = 0 ] &&
+ rm "$x/fonts.scale"
+ [ "$(head -1 "$x/fonts.dir" >$devnull 2>&1)" = 0 ] &&
+ rm "$x/fonts.dir"
+ l "$share${y#gui}/$(basename "$x")"
+ done
+ ;;
+ *)
+ find "$y" -mindepth 1 -maxdepth 1 | while read -r x; do
+ l "$share${x#gui}"
+ done
+ ;;
+ esac
+done
+
+# gpg
+if command -v gpg >$devnull 2>&1; then
+ mkdir -pm 700 "$DEST/$etc/gnupg"
+ find gnupg -mindepth 1 -maxdepth 1 \! -name '*.gpg' | while read -r x; do
+ l "$etc/$x"
+ done
+ find gnupg -mindepth 1 -maxdepth 1 -name '*.gpg' | while read -r x; do
+ gpg --import "$x"
+ done
+fi
+
+# ssh
+if command -v ssh >$devnull 2>&1; then
+ mkdir -pm 700 "$DEST/.ssh"
+ find ssh -mindepth 1 -maxdepth 1 | while read -r x; do
+ l ".$x"
+ done
+fi
+
+# librewolf
+if command -v librewolf >$devnull 2>&1; then
+ # XXX: MOZ_USER_DIR is compiletime, can't move to .config :(
+ mkdir -p "$DEST/.librewolf"
+ find librewolf -mindepth 1 -maxdepth 1 -type f | while read -r x; do
+ l ".$x"
+ done
+ profiles="$DEST/.librewolf/profiles.ini"
+ if [ -f "$profiles" ]; then
+ find librewolf/chrome -mindepth 1 -maxdepth 1 -type f | while read -r x; do
+ # vv arcane bullshit vv
+ sed -En 's/^Path=(.+)/\1/;T;p' "$profiles" | while read -r y; do
+ # ignore profiles that are most likely unused
+ # TODO: actually check profiles.ini
+ profile="$DEST/.librewolf/$y"
+ [ -d "$profile" -a -f "$profile/prefs.js" ] || continue
+ mkdir -p "$profile/chrome"
+ l "${profile#$DEST/}/chrome/${x#librewolf/chrome/}"
+ done
+ done
+ fi
+fi
+
+# termux, assume it if android
+if [ $(uname -o) = 'Android' ]; then
+ mkdir -p "$DEST/.termux"
+ find termux -mindepth 1 -maxdepth 1 | while read -r x; do l ".$x"; done
+ l '.termux/font.ttf' "gui/fonts/Dina-ttf/Dina.ttf"
+fi
+
+cd "$DEST" >$devnull
+
+# ensure xdg user dirs, and move old to new while we're at it
+. $etc/user-dirs.dirs
+fixup_xdg_home() {
+ if [ -z "$1" -o "${1#/}" = "$1" -o "$(realpath "$1")" = "$(realpath "$HOME")" ]; then
+ return;
+ fi
+ mkdir -p "$1"
+ if [ $? -eq 0 -a -n "$2" -a -d "$2" ]; then
+ mv "$2"/* $1
+ rmdir "$2"
+ fi
+}
+fixup_xdg_home "$XDG_DESKTOP_DIR" Desktop
+fixup_xdg_home "$XDG_DOWNLOAD_DIR" Downloads
+fixup_xdg_home "$XDG_TEMPLATES_DIR"
+fixup_xdg_home "$XDG_PUBLICSHARE_DIR" Public
+fixup_xdg_home "$XDG_DOCUMENTS_DIR" Documents
+fixup_xdg_home "$XDG_MUSIC_DIR" Music
+fixup_xdg_home "$XDG_PICTURES_DIR" Pictures
+fixup_xdg_home "$XDG_VIDEOS_DIR" Videos
+
+cd "$old_pwd"